namespace Circonferenze {

public class Principale {

    public void Esegui() {
        int numeroCirconferenze = SchermoLeggiNumeroCirconferenze();
        if (numeroCirconferenze > 0) {
            Circonferenza[] collezione = new Circonferenza[numeroCirconferenze];
            for (int i = 0; i < numeroCirconferenze; i++) {
                collezione[i] = SchermoLeggiDatiCirconferenza();
            }
            for (int i = 0; i < numeroCirconferenze; i++) {
                SchermoStampaDatiCirconferenza(collezione[i]);
            }
            System.Console.WriteLine("\nLa circonferenza di lunghezza massima  in posizione: " +
                                  Circonferenza.PosizioneMassimaCirconferenza(collezione));
        }
        System.Console.WriteLine("\nArrivederci.");
    }

    private int SchermoLeggiNumeroCirconferenze() {
        System.Console.WriteLine("------------------------------------");
        System.Console.WriteLine("   Analisi circonferenze");
        System.Console.WriteLine("------------------------------------\n");
        System.Console.WriteLine("Quante circonferenze vuoi analizzare ?");
        System.Console.Write("---> ");
        int numeroCirconferenze = Unibas.Utilita.Console.LeggiIntero();
        while (numeroCirconferenze < 0) {
            System.Console.WriteLine("Errore. Numero scorretto.");
            System.Console.Write("Ripeti. ---> ");
            numeroCirconferenze = Unibas.Utilita.Console.LeggiIntero();
        }
        return numeroCirconferenze;
    }

    private Circonferenza SchermoLeggiDatiCirconferenza() {
        System.Console.WriteLine("\nImmetti i dati della circonferenza:");
        System.Console.Write("Ascissa del centro: --> ");
        double ascissaCentro = Unibas.Utilita.Console.LeggiDouble();
        System.Console.Write("Ordinata del centro: --> ");
        double ordinataCentro = Unibas.Utilita.Console.LeggiDouble();
        double raggio = SchermoLeggiRaggio();
        Circonferenza circonferenza = new Circonferenza(ascissaCentro, ordinataCentro, raggio);
        return circonferenza;
    }

    private double SchermoLeggiRaggio() {
        System.Console.Write("Lunghezza del raggio: --> ");
        double raggio = Unibas.Utilita.Console.LeggiDouble();
        while (raggio <= 0) {
            System.Console.WriteLine("Errore. Numero scorretto.");
            System.Console.Write("Ripeti. ---> ");
            raggio = Unibas.Utilita.Console.LeggiDouble();
        }
        return raggio;
    }

    private void SchermoStampaDatiCirconferenza(Circonferenza circonferenza) {
        System.Console.WriteLine("\nDati della circonferenza:");
        System.Console.WriteLine("Ascissa del centro: " + circonferenza.GetAscissaCentro());
        System.Console.WriteLine("Ordinata del centro: " + circonferenza.GetOrdinataCentro());
        System.Console.WriteLine("Lunghezza del raggio: " + circonferenza.GetRaggio());
        System.Console.WriteLine("Lunghezza circonferenza: " + circonferenza.GetLunghezzaCirconferenza());
        System.Console.WriteLine("Superficie cerchio: " + circonferenza.GetSuperficieCerchio());
    }

    public static void Main(string[] args) {
        Principale principale = new Principale();
        principale.Esegui();
    }

}

}
