namespace Circonferenze {

using NUnit.Framework;

[TestFixture]
public class TestCirconferenza {

    private Circonferenza circonferenza;

    [SetUp]
    protected void SetUp() {
        circonferenza = new Circonferenza();
    }
    
    [Test]
    public void TestGetLunghezzaCirconferenza1() {
        circonferenza.SetAscissaCentro(0);
        circonferenza.SetOrdinataCentro(0);
        circonferenza.SetRaggio(0);
        Assert.IsTrue(circonferenza.GetLunghezzaCirconferenza() == 0, "lunghezza circ. 1");
    }

    [Test]
    public void TestGetLunghezzaCirconferenza2() {
        circonferenza.SetAscissaCentro(1.5);
        circonferenza.SetOrdinataCentro(0);
        circonferenza.SetRaggio(1.7);
        Assert.IsTrue(Uguali(circonferenza.GetLunghezzaCirconferenza(), 10.676), "lunghezza circ. 1");
    }

    [Test]
    public void TestGetSuperficieCerchio1() {
        circonferenza.SetAscissaCentro(0);
        circonferenza.SetOrdinataCentro(0);
        circonferenza.SetRaggio(0);
        Assert.IsTrue(circonferenza.GetSuperficieCerchio() == 0, "superficie cerchio 1");
    }

    [Test]
    public void TestGetSuperficieCerchio2() {
        circonferenza.SetAscissaCentro(1.5);
        circonferenza.SetOrdinataCentro(0);
        circonferenza.SetRaggio(1.7);
        Assert.IsTrue(Uguali(circonferenza.GetSuperficieCerchio(), 9.0746), "superficie cerchio 2");
    }

    [Test]
    public void TestPosizioneMassimaCirconferenza1() {
        Circonferenza c1 = new Circonferenza(0, 0, 1);
        Circonferenza c2 = new Circonferenza(0, 0, 5);
        Circonferenza c3 = new Circonferenza(0, 0, 0.5);
        Circonferenza[] collezione = {c1, c2, c3};
        Assert.IsTrue(Circonferenza.PosizioneMassimaCirconferenza(collezione) == 1, "max. circonferenza 1");
    }

    [Test]
    public void TestPosizioneMassimaCirconferenza2() {
        Circonferenza c1 = new Circonferenza(0, 0, 1);
        Circonferenza[] collezione = {c1};
        Assert.IsTrue(Circonferenza.PosizioneMassimaCirconferenza(collezione) == 0, "max. circonferenza 2");
    }

    [Test]
    public void TestPosizioneMassimaCirconferenza3() {
        try {
            Circonferenza.PosizioneMassimaCirconferenza(null);
            Assert.Fail();
        } catch (System.Exception) {}
        try {
            Circonferenza.PosizioneMassimaCirconferenza(new Circonferenza[0]);
            Assert.Fail();
        } catch (System.Exception) {}
    }

    private bool Uguali(double a, double b) {
        return (System.Math.Abs(a - b) < 1E-10);
    }
}

}