namespace Circonferenze {

using System;

[Serializable]
public class Circonferenza {
    
    public const double PIGRECO = 3.14;
    
    public static int PosizioneMassimaCirconferenza(Circonferenza[] collezione) {
        if (collezione == null || collezione.Length == 0) {
            throw new ArgumentException("Array vuoto");
        } else {
            int posizioneMassimo = 0;
            for (int i = 1; i < collezione.Length; i++) {
                if (collezione[posizioneMassimo].LunghezzaCirconferenza < 
                    collezione[i].LunghezzaCirconferenza) {
                        posizioneMassimo = i;
                }
            }
            return posizioneMassimo;
        }
    }
    
    [Obsolete("Si consiglia di utilizzare l'altro costruttore")]
    public Circonferenza(double ascissaCentro, double ordinataCentro, double raggio) {
        this.raggio = raggio;
        this.ascissaCentro = ascissaCentro;
        this.ordinataCentro = ordinataCentro;
    }

    public Circonferenza() {}

    private double ascissaCentro;
    private double ordinataCentro;
    private double raggio;
    
    public double AscissaCentro {
        get {
            return this.ascissaCentro;
        }
        set {
            this.ascissaCentro = value;
        }
    }

    public double OrdinataCentro {
        get {
            return this.ordinataCentro;
        }
        set {
            this.ordinataCentro = value;
        }
    }

    public double Raggio {
        get {
            return this.raggio;
        }
        set {
            this.raggio = value;
        }
    }
    
            
    public double LunghezzaCirconferenza {
        get {
            return (2 * Circonferenza.PIGRECO * this.raggio);
        }
    }
    
    public double SuperficieCerchio {
        get {
            return (Circonferenza.PIGRECO * this.raggio * this.raggio);
        }
    }
    
    public int QuadranteCentro {
        get {
            int quadrante = 1;
            if (this.ascissaCentro < 0 && this.ordinataCentro >= 0) {
                quadrante = 2;
            } else if (this.ascissaCentro < 0 && this.ordinataCentro < 0) {
                quadrante = 3;
            } else if (this.ascissaCentro >= 0 && this.ordinataCentro < 0) {
                quadrante = 4;
            }   
            return quadrante;
        }
    }
}

}
