namespace Segmenti {

using NUnit.Framework;

[TestFixture]
public class TestSegmento {

    private Segmento segmento;
    
    [SetUp]
    protected void SetUp() {
        segmento = new Segmento();
    }
    
    [Test]
    public void TestGetLunghezza1() {
        CostruisciSegmento(1, 2, 4, 6);
        Assert.IsTrue(segmento.Lunghezza == 5, "lunghezza");
    }
    
    [Test]
    public void TestGetLunghezza2() {
        CostruisciSegmento(-1, 2, 1, -2);
        Assert.IsTrue(segmento.Lunghezza == System.Math.Sqrt(4 + 16), "lunghezza");
    }

    [Test]
    public void testGetLunghezza3() {
        CostruisciSegmento(-2, -2, -2, -2);
        Assert.IsTrue(segmento.Lunghezza == 0, "lunghezza");
    }

    private void CostruisciSegmento(double x1, double y1, double x2, double y2) {
        Punto p1 = new Punto();
        p1.Ascissa = x1;
        p1.Ordinata = y1;
        Punto p2 = new Punto();
        p2.Ascissa = x2;
        p2.Ordinata = y2;
        segmento.PrimoVertice = p1;
        segmento.SecondoVertice = p2;
    }
    
    private bool Uguali(double a, double b) {
        return (System.Math.Abs(a - b) < 1E-10);
    }
    
}

}